[![DOI](https://zenodo.org/badge/168945305.svg)](https://zenodo.org/badge/latestdoi/168945305)

[![Documentation Status](https://readthedocs.org/projects/profit/badge/?version=latest)](https://profit.readthedocs.io/en/latest/?badge=latest)
[![Python package](https://github.com/redmod-team/profit/actions/workflows/python-package.yml/badge.svg?)](https://github.com/redmod-team/profit/actions/workflows/python-package.yml)
[![Publish Releases to PyPI](https://github.com/redmod-team/profit/actions/workflows/publish-to-pypi.yml/badge.svg)](https://github.com/redmod-team/profit/actions/workflows/publish-to-pypi.yml)

<img src="https://raw.githubusercontent.com/redmod-team/profit/master/logo.png" width="208.5px">

# Probabilistic Response Model Fitting with Interactive Tools

This is a collection of tools for studying parametric dependencies of 
black-box simulation codes or experiments and construction of reduced 
order response models over input parameter space. 

proFit can be fed with a number of data points consisting of different 
input parameter combinations and the resulting output of the model under 
investigation. It then fits a response "surface" through the point cloud.
This probabilistic response model allows to predict ("interpolate") the output 
at yet unexplored parameter combinations including uncertainty estimates. 
It can also tell you where to put more training points to gain maximum new 
information (experimental design) and automatically generate and start
new simulation runs locally or on a cluster. Results can be explored and checked 
visually in a web frontend.

Telling proFit how to interact with your existing simulations is easy
and requires no changes in your existing code. Current functionality covers 
uncertainty quantification via polynomial chaos expansion 
with [chaospy](https://github.com/jonathf/chaospy) as a backend. Support for 
response surface / surrogate models via 
[GPflow](https://github.com/GPflow/GPflow) is under development. 
The web frontend is based on [plotly/dash](https://github.com/plotly/dash).

## Features

* Compute evaluation points to run simulation for UQ (full or sparse grid)
* Template replacement and automatic generation of run directories
* Starting parallel runs locally or on the cluster (SLURM)
* Collection of result output and postprocessing with UQ

## Installation

Currently, the code is under heavy development, so it should be cloned 
from GitHub via Git and pulled regularly.

### Requirements
```bash
sudo apt install python3-dev build-essential
```
To enable compilation of the fortran modules the following is needed:
```bash
sudo apt install gfortran
```

### Dependencies
* numpy, scipy, matplotlib, sympy, pandas
* [ChaosPy](https://github.com/jonathf/chaospy)
* GPy
* scikit-learn
* h5py
* [plotly/dash](https://github.com/plotly/dash) - for the UI
* [ZeroMQ](https://github.com/zeromq/pyzmq) - for messaging
* sphinx - for documentation, only needed when `docs` is specified
* torch, GPyTorch - only needed when `gpu` is specified

All dependencies are configured in `setup.cfg` and should be installed automatically when using `pip`.

Automatic tests use `pytest`.

### Windows 10
To install proFit under Windows 10 we recommend using *Windows Subsystem 
for Linux (WSL2)* with the Ubuntu 20.04 LTS distribution ([install guide](https://docs.microsoft.com/en-us/windows/wsl/install-win10)).

After the installation of WSL2 execute the following steps in your Linux terminal (when asked press `y` to continue):

1. Make sure you have the right version of Python installed and the basic developer toolset available
   ```bash
   sudo apt update
   sudo apt install python3 python3-pip python3-dev build-essential
   ```

2. To install proFit from Git, make sure that the project is located in the Linux file system
not the Windows system, and follow the steps in the next section.

To configure the Python interpreter available in your Linux distribution in pycharm
(tested with professional edition) follow this [guide](https://www.jetbrains.com/help/pycharm/using-wsl-as-a-remote-interpreter.html).

### Installation from Git
To install proFit for the current user (`--user`) in development-mode (`-e`) use:
```bash
git clone https://github.com/redmod-team/profit.git
cd profit
pip install -e . --user
```

### Fortran
Certain surrogates require a compiled Fortran backend. To enable compilation of the fortran modules during install:

    USE_FORTRAN=1 pip install .

### Troubleshooting installation problems
1. Make sure you have all the requirements mentioned above installed.

2. If `pip` is not recognized try the following:
```bash
python3 -m pip install -e . --user
```
3. If pip warns you about PATH or proFit is not found close and reopen the terminal 
   and type `profit --help` to check if the installation was successful.


### Documentation using *Sphinx*
Install requirements for building the documentation using `sphinx`

    pip install .[docs] 

## HowTo

Examples for different model codes are available under `examples/`:
* `fit`: Simple fit via python interface.
* `mockup`: Simple model called by console command based on template directory.


1. Create and enter a directory (e.g. `study`) containing `profit.yaml` for your run.
    If your code is based on text configuration files for each run, copy the according directory to `template` and 
    replace values of parameters to be varied within UQ/surrogate models by placeholders `{param}`.
  
2. Running the simulations: 
   ```bash
   profit run
   ```
   to start simulations at all the points. Per default the generated input variables are written to `input.txt` and the 
   output data is collected in `output.txt`.
   
   For each run of the simulation, proFit creates a run directory, fills the templates with the generated input data and
   collects the results. Each step can be customized with the 
   [configuration file](https://profit.readthedocs.io/en/latest/config.html).

3. To fit the model:
   ```bash
   profit fit
   ```
   Customization can be done with `profit.yaml` again.
   
4. Explore data graphically: 
   ```bash
   profit ui
   ```
   starts a Dash-based browser UI

### Cluster
proFit supports scheduling the runs on a cluster using *slurm*. This is done entirely via the configuration files and
the usage doesn't change.

`profit ui` starts a *dash* server and it is possible to remotely connect to it (e.g. via *ssh port forwarding*)
  
## User-supplied files

* a [configuration file](https://profit.readthedocs.io/en/latest/config.html): (default: `profit.yaml`)
  * Add parameters and their distributions via `variables`
  * Set paths and filenames
  * Configure the run backend (how to interact with the simulation)
  * Configure the fit / surrogate model
  
* the `template` directory
  * containing everything a simulation run needs (scripts, links to executables, input files, etc)
  * input files use a template format where `{variable_name}` is substituted with the generated values

* a custom *Postprocessor* (optional)
  * if the default postprocessors don't work with the simulation a custom one can be specified

This is a mockup example case for proFit.

Two ways of running proFit:

1) Using the console scripts based on config files
2) Using the Python API

Let's assume we have a simulation code that is run by calling 

```
python mockup.py 
```

Here, `mockup.py` requires two scalar input parameters: `u` and `v` and returns a scalar result `f(u,v)`.
The input is read from an input file `mockup.in`. After computation, the output is saved to `mockup.out`.

## Parameter study via console scripts
We want to do a parameter study by varying `u` and `v`. First we enter the `study` directory and
edit the file `profit.yaml`. Then we generate run directories with
```
profit pre
```
This will generate run directories `run` where `u` and `v` are replaced by quasi-random values
inside the domain of interest. In addition a file `input.txt` containing all parameter 
combinations for runs is generated.

Now we can start runs with
```
profit run
```

Results from run folders are collected with
```
profit collect
```
yielding a file `output.txt` with the entries from `run` directories.

To fit results:
```
profit fit
```
In addition, it generates a file 'profit.hdf5 where the data is stored.

We can view these results in the browser via
```
profit ui
```

module modu
    implicit none

    type :: t
        real(8) :: x(100, 100), y(100)
    end type
end module modu


program test
    use modu
    implicit none
    integer, parameter :: n = 100
    !real(8) :: x(n), y(n)
    real(8), allocatable :: x(:,:), y(:)
    type(t) :: ti

    ti%x = cos(ti%x) + sin(cos(ti%x))

    allocate(x(n,n), y(n))
    x = 1.0d0


    ti%x = 1.0d0
    !call evil(x, y, func)
    print *, ti%y(1)

    ! SIMD
    ! real(8) :: temp(n)
    ! do k = 1,n
    !   temp(k) = sin(x(k))
    ! end do
    ! do k = 1,n
    !   y(k) = cos(temp(k))
    ! end do
    !
    ! SIMD without TEMP
    ! do k = 1,n
    !   y(k) = sin(x(k))
    ! end do
    ! do k = 1,n
    !   y(k) = cos(y(k))
    ! end do
    !
    ! NON-SIMD
    ! do k = 1,n
    !   y(k) = cos(sin(x(k)))
    ! end do
    !
    ! y(:) = x(:)*f(z(:))
    ! y(:) = t%x(:)*f(t2%z(:))
    !
    ! -heap-arrays
    !
    deallocate(x, y)

    contains


    ! subroutine func(a, b)
    !     real(8) :: a(:), b(:)
    !     b = cos(a) + sin(cos(a))
    ! end subroutine func

    ! subroutine evil(a, b, func2)
    !     real(8) :: a(:, :), b(:)
    !     external func2
    !     call func2(a(10, :), b)
    ! end subroutine evil

end program test

module kernels
implicit none

contains

function kern_prod(k, x, l) result(y)
  external :: k        ! Base kernel
  real(8) :: k
  real(8), intent(in)  :: x(:)  ! Input argument
  real(8), intent(in)  :: l(:)  ! Length scales
  real(8) :: y
  integer :: i
  y = 1d0
  do i = 1, size(x)
    y = y*k(x(i)/l(i))
  end do
end function

function dkern_prod(k, dk, j, x, l) result(y)
  external :: k        ! Base kernel
  real(8) :: k
  external :: dk        ! Base kernel
  real(8) :: dk       ! Derivative of base kernel
  integer, intent(in) :: j      ! Direction to differentiate
  real(8), intent(in)  :: x(:)  ! Input argument
  real(8), intent(in)  :: l(:)  ! Length scales
  real(8) :: y
  integer :: i
  y = 1d0
  do i = 1, size(x)
    if (i == j) then
      y = y*dk(x(i)/l(i))/l(i)  ! Factor for direction to differentiate
    else
      y = y*k(x(i)/l(i))        ! Usual factor
    end if
  end do
end function


end module kernels

using Dash
using DashHtmlComponents
using DashCoreComponents

app = dash(external_stylesheets = ["https://codepen.io/chriddyp/pen/bWLwgP.css"])

app.layout = html_div() do
        html_h1("Hello Dash"),
        html_div("Dash.jl: Julia interface for Dash"),
        dcc_graph(
            id = "example-graph",
            figure = (
                data = [
                    (x = [1, 2, 3], y = [100, 1, 2], type = "bar", name = "SF"),
                    (x = [1, 2, 3], y = [2, 4, 5], type = "bar", name = "Montréal"),
                ],
                layout = (title = "Dash Data Visualization 2",)
            )
        )
    end

run_server(app, "0.0.0.0", 8080)

REAL*8 function kern_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
kern_num = exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2/ &
      lx**2)
end function
REAL*8 function dkdx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx_num = -exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(x_a - x_b)*cos(x_a - x_b)/lx**2
end function
REAL*8 function dkdy_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy_num = -exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(y_a - y_b)*cos(y_a - y_b)/ly**2
end function
REAL*8 function dkdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx0_num = exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(x_a - x_b)*cos(x_a - x_b)/lx**2
end function
REAL*8 function dkdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy0_num = exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(y_a - y_b)*cos(y_a - y_b)/ly**2
end function
REAL*8 function d2kdxdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdx0_num = (-lx**2*sin(x_a - x_b)**2 + lx**2*cos(x_a - x_b)**2 - sin &
      (x_a - x_b)**2*cos(x_a - x_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2/ly &
      **2 - 0.5d0*sin(x_a - x_b)**2/lx**2)/lx**4
end function
REAL*8 function d2kdydy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdydy0_num = (-ly**2*sin(y_a - y_b)**2 + ly**2*cos(y_a - y_b)**2 - sin &
      (y_a - y_b)**2*cos(y_a - y_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2/ly &
      **2 - 0.5d0*sin(x_a - x_b)**2/lx**2)/ly**4
end function
REAL*8 function d2kdxdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdy0_num = -exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b &
      )**2/lx**2)*sin(x_a - x_b)*sin(y_a - y_b)*cos(x_a - x_b)*cos(y_a &
      - y_b)/(lx**2*ly**2)
end function
REAL*8 function d3kdxdx0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dy0_num = (-lx**2*sin(x_a - x_b)**2 + lx**2*cos(x_a - x_b)**2 - &
      sin(x_a - x_b)**2*cos(x_a - x_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2 &
      /ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(y_a - y_b)*cos(y_a - &
      y_b)/(lx**4*ly**2)
end function
REAL*8 function d3kdydy0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dy0_num = (4*ly**4 + 3*ly**2*cos(2.0d0*y_a - 2.0d0*y_b) - sin( &
      y_a - y_b)**2*cos(y_a - y_b)**2)*exp(-0.5d0*(lx**2*sin(y_a - y_b) &
      **2 + ly**2*sin(x_a - x_b)**2)/(lx**2*ly**2))*sin(y_a - y_b)*cos( &
      y_a - y_b)/ly**6
end function
REAL*8 function d3kdxdy0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dy0_num = (-ly**2*sin(y_a - y_b)**2 + ly**2*cos(y_a - y_b)**2 - &
      sin(y_a - y_b)**2*cos(y_a - y_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2 &
      /ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(x_a - x_b)*cos(x_a - &
      x_b)/(lx**2*ly**4)
end function
REAL*8 function dkdlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdlx_num = exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(x_a - x_b)**2/lx**3
end function
REAL*8 function dkdly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdly_num = exp(-0.5d0*sin(y_a - y_b)**2/ly**2 - 0.5d0*sin(x_a - x_b)**2 &
      /lx**2)*sin(y_a - y_b)**2/ly**3
end function
REAL*8 function d3kdxdx0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dlx_num = (-2*lx**4*cos(2.0d0*x_a - 2.0d0*x_b) + lx**2*(3*cos( &
      2.0d0*x_a - 2.0d0*x_b) + 2)*sin(x_a - x_b)**2 - sin(x_a - x_b)**4 &
      *cos(x_a - x_b)**2)*exp(-0.5d0*(lx**2*sin(y_a - y_b)**2 + ly**2* &
      sin(x_a - x_b)**2)/(lx**2*ly**2))/lx**7
end function
REAL*8 function d3kdydy0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dlx_num = (-ly**2*sin(y_a - y_b)**2 + ly**2*cos(y_a - y_b)**2 - &
      sin(y_a - y_b)**2*cos(y_a - y_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2 &
      /ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(x_a - x_b)**2/(lx**3* &
      ly**4)
end function
REAL*8 function d3kdxdy0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dlx_num = (2*lx**2 - sin(x_a - x_b)**2)*exp(-0.5d0*sin(y_a - y_b &
      )**2/ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(x_a - x_b)*sin( &
      y_a - y_b)*cos(x_a - x_b)*cos(y_a - y_b)/(lx**5*ly**2)
end function
REAL*8 function d3kdxdx0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dly_num = (-lx**2*sin(x_a - x_b)**2 + lx**2*cos(x_a - x_b)**2 - &
      sin(x_a - x_b)**2*cos(x_a - x_b)**2)*exp(-0.5d0*sin(y_a - y_b)**2 &
      /ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(y_a - y_b)**2/(lx**4* &
      ly**3)
end function
REAL*8 function d3kdydy0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dly_num = (-2*ly**4*cos(2.0d0*y_a - 2.0d0*y_b) + ly**2*(3*cos( &
      2.0d0*y_a - 2.0d0*y_b) + 2)*sin(y_a - y_b)**2 - sin(y_a - y_b)**4 &
      *cos(y_a - y_b)**2)*exp(-0.5d0*(lx**2*sin(y_a - y_b)**2 + ly**2* &
      sin(x_a - x_b)**2)/(lx**2*ly**2))/ly**7
end function
REAL*8 function d3kdxdy0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dly_num = (2*ly**2 - sin(y_a - y_b)**2)*exp(-0.5d0*sin(y_a - y_b &
      )**2/ly**2 - 0.5d0*sin(x_a - x_b)**2/lx**2)*sin(x_a - x_b)*sin( &
      y_a - y_b)*cos(x_a - x_b)*cos(y_a - y_b)/(lx**2*ly**5)
end function

REAL*8 function kern_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
kern_num = cos(sqrt((y_a - y_b)**2/ly**2 + (x_a - x_b)**2/lx**2))
end function
REAL*8 function dkdx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx_num = -(x_a - x_b)*sin(sqrt((lx**2*(y_a - y_b)**2 + ly**2*(x_a - &
      x_b)**2)/(lx**2*ly**2)))/(lx**2*sqrt((lx**2*(y_a - y_b)**2 + ly** &
      2*(x_a - x_b)**2)/(lx**2*ly**2)))
end function
REAL*8 function dkdy_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy_num = -(y_a - y_b)*sin(sqrt((lx**2*(y_a - y_b)**2 + ly**2*(x_a - &
      x_b)**2)/(lx**2*ly**2)))/(ly**2*sqrt((lx**2*(y_a - y_b)**2 + ly** &
      2*(x_a - x_b)**2)/(lx**2*ly**2)))
end function
REAL*8 function dkdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx0_num = (x_a - x_b)*sin(sqrt((lx**2*(y_a - y_b)**2 + ly**2*(x_a - &
      x_b)**2)/(lx**2*ly**2)))/(lx**2*sqrt((lx**2*(y_a - y_b)**2 + ly** &
      2*(x_a - x_b)**2)/(lx**2*ly**2)))
end function
REAL*8 function dkdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy0_num = (y_a - y_b)*sin(sqrt((lx**2*(y_a - y_b)**2 + ly**2*(x_a - &
      x_b)**2)/(lx**2*ly**2)))/(ly**2*sqrt((lx**2*(y_a - y_b)**2 + ly** &
      2*(x_a - x_b)**2)/(lx**2*ly**2)))
end function
REAL*8 function d2kdxdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdx0_num = ly**2*(lx**2*ly**2*sqrt((lx**2*(y_a - y_b)**2 + ly**2*( &
      x_a - x_b)**2)/(lx**2*ly**2))*(-(x_a - x_b)**2 + (lx**2*(y_a - &
      y_b)**2 + ly**2*(x_a - x_b)**2)/ly**2)*sin(sqrt((lx**2*(y_a - y_b &
      )**2 + ly**2*(x_a - x_b)**2)/(lx**2*ly**2))) + (x_a - x_b)**2*(lx &
      **2*(y_a - y_b)**2 + ly**2*(x_a - x_b)**2)*cos(sqrt((lx**2*(y_a - &
      y_b)**2 + ly**2*(x_a - x_b)**2)/(lx**2*ly**2))))/(lx**2*(lx**2*( &
      y_a - y_b)**2 + ly**2*(x_a - x_b)**2)**2)
end function
REAL*8 function d2kdydy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdydy0_num = lx**2*(lx**2*ly**2*sqrt((lx**2*(y_a - y_b)**2 + ly**2*( &
      x_a - x_b)**2)/(lx**2*ly**2))*(-(y_a - y_b)**2 + (lx**2*(y_a - &
      y_b)**2 + ly**2*(x_a - x_b)**2)/lx**2)*sin(sqrt((lx**2*(y_a - y_b &
      )**2 + ly**2*(x_a - x_b)**2)/(lx**2*ly**2))) + (y_a - y_b)**2*(lx &
      **2*(y_a - y_b)**2 + ly**2*(x_a - x_b)**2)*cos(sqrt((lx**2*(y_a - &
      y_b)**2 + ly**2*(x_a - x_b)**2)/(lx**2*ly**2))))/(ly**2*(lx**2*( &
      y_a - y_b)**2 + ly**2*(x_a - x_b)**2)**2)
end function
REAL*8 function d2kdxdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdy0_num = (x_a - x_b)*(y_a - y_b)*(cos(sqrt((y_a - y_b)**2/ly**2 + &
      (x_a - x_b)**2/lx**2))/((y_a - y_b)**2/ly**2 + (x_a - x_b)**2/lx &
      **2) - sin(sqrt((y_a - y_b)**2/ly**2 + (x_a - x_b)**2/lx**2))/(( &
      y_a - y_b)**2/ly**2 + (x_a - x_b)**2/lx**2)**(3.0d0/2.0d0))/(lx** &
      2*ly**2)
end function

program bench_inline
use gpfunc, only: build_K, build_K_sqexp, build_K_vec, kern_sqexp_vec, &
    kern_sqexp_elem, build_K_sqexp_T, build_K_vec_T, kern_sqexp_vec_T, &
    build_K_der, Kernel, CompositeKernel, kern_sqexp_1D, build_K_prod, &
    build_K_interface, SqExpGP, kern_one_1D
implicit none

integer, parameter :: np = 4096
integer, parameter :: ndim = 3

real(8), allocatable :: x(:, :), xT(:,:)
real(8), allocatable :: K(:, :)
integer :: kn, kd
integer(8) :: count, count_rate, count_max
real(8) :: tic, toc

type(Kernel) :: kern_holder
type(CompositeKernel) :: prod_kern
type(SqExpGP) :: sqexp_gp

integer(8) :: kk

! real(8), external :: kern_sqexp

allocate(K(np, np), x(np, ndim), xT(ndim, np))

do kn = 1, np
    do kd = 1, ndim
        call random_number(x(kn, kd))
    end do
end do

xT = transpose(x)

!-------------------------------------------------------------------------------
! Element-wise kernel
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K(np, ndim, xT, xT, K, kern_sqexp_elem)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''

!-------------------------------------------------------------------------------
! Element-wise kernel
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K(np, ndim, xT, xT, K, kern_sqexp_elem)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''

!-------------------------------------------------------------------------------
! Element-wise kernel with interface
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K_interface(np, ndim, xT, xT, K, kern_sqexp_elem)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_interface:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''


!-------------------------------------------------------------------------------
! Element-wise kernel with polymorphism
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call sqexp_gp%build_K_poly(np, ndim, xT, xT, K)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_poly:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''

!-------------------------------------------------------------------------------
! Row-wise kernel
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K_vec(np, ndim, x, x, K, kern_sqexp_vec)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_vec:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''

!-------------------------------------------------------------------------------
! Inline in loop
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K_sqexp(np, ndim, x, x, K)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_sqexp:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''


!-------------------------------------------------------------------------------
! Inline in loop array of structs
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K_sqexp_T(np, ndim, xT, xT, K)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_sqexp_T:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''


!-------------------------------------------------------------------------------
! Row-wise array of structs
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K_vec_T(np, ndim, xT, xT, K, kern_sqexp_vec_T)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_vec_T:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''



!-------------------------------------------------------------------------------
! Row-wise kernel with derived type and function pointer
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

kern_holder%kern => kern_sqexp_vec

call build_K_der(np, ndim, x, x, K, kern_holder)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_vec_der:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''


!-------------------------------------------------------------------------------
! Product kernel with derived type and function pointer
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

allocate(prod_kern%kernels(ndim))
prod_kern%kernels(1)%kern => kern_one_1D
do kk = 2, ndim
    prod_kern%kernels(kk)%kern => kern_sqexp_1D
end do

call build_K_prod(np, ndim, x, x, K, prod_kern)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_prod:', toc - tic, 'ms'
print *, K(5,5), K(np,np-5)
print *, ''

deallocate(prod_kern%kernels)
deallocate(K, x)


end program bench_inline

program test
    implicit none

    integer :: i, j
    integer, parameter :: n1 = 10000, n2 = 32
    real(8), allocatable :: x(:, :)

    real(8) :: time_start, time_end, elapsed_time, time_min
    integer(8) :: count_start, count_end, count_rate, count_max, T, T_scale, k

    T = 1
    T_scale = 2
    time_min = 1d0

    allocate(x(n1, n2))
    x = 1.0d0

    do
    call system_clock(count_start, count_rate, count_max)
    do k = 1, T
    !$omp parallel
    !!$omp do schedule(static)
        do j = 1, n2
            !$omp do simd schedule(static)
            !!$omp simd
            do i = 1, n1
                x(i, j) = sin(exp(2.0d0*x(i, j)))
            end do
            !!$omp end simd
            !$omp end do simd
        end do
    !!$omp end do
    !$omp end parallel
    end do

    call system_clock(count_end, count_rate, count_max)

    time_start = (count_start*1.0_8)/count_rate
    time_end = (count_end*1.0_8)/count_rate
    elapsed_time = time_end - time_start

    if(elapsed_time < time_min) then
        T = int(T * T_scale)
    else
        print *, "         T (end) =", T
        print *, elapsed_time/real(T, 8)
        exit
    end if
    end do

    deallocate(x)

end program test

##
using QuasiMonteCarlo: LowDiscrepancySample, sample
using Plots

function kern_sqexp(x)
    exp(-x^2/2)
end

function cov!(K, kernel, x1, x2, l)
    for (k1, xv1) in enumerate(x1)
        for (k2, xv2) in enumerate(x2)
        end
    end
end

lb = [0.0, -0.5]  # Lower bounds
ub = [4.0, 3.5]   # Upper bounds
n = 100           # Number of samples

halton = LowDiscrepancySample([3, 5])  # Halton with prime number sequence
xtrain = sample(n, lb, ub, halton)

scatter(xtrain[1,:], xtrain[2,:])
##

# f(x) = cos.(x[1,:]).*sin.(x[2,:])
# ytrain = f(xtrain)

# #scatter3d(xtrain[1,:], xtrain[2,:], ytrain, marker_z=ytrain)
# #savefig("test.png")

REAL*8 function kern_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
kern_num = sin(sqrt((x_a - x_b)**2/lx**2))
end function
REAL*8 function dkdx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx_num = sqrt((x_a - x_b)**2/lx**2)*cos(sqrt((x_a - x_b)**2/lx**2))/( &
      x_a - x_b)
end function
INTEGER*4 function dkdy_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy_num = 0
end function
REAL*8 function dkdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx0_num = -sqrt((x_a - x_b)**2/lx**2)*cos(sqrt((x_a - x_b)**2/lx**2))/ &
      (x_a - x_b)
end function
INTEGER*4 function dkdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy0_num = 0
end function
REAL*8 function d2kdxdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdx0_num = sin(sqrt((x_a - x_b)**2/lx**2))/lx**2
end function
INTEGER*4 function d2kdydy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdydy0_num = 0
end function
INTEGER*4 function d2kdxdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdy0_num = 0
end function

program bench_inline
use gpfunc, only: build_K, kern_sqexp
implicit none

integer, parameter :: nx = 4096
integer, parameter :: nd = 4

real(8), allocatable :: x(:, :), y(:), l(:)
real(8), allocatable :: K(:, :)
integer :: kx, kd
integer(8) :: count, count_rate, count_max
real(8) :: tic, toc

integer :: info

external :: dpotrf
external :: dtrmv

allocate(K(nx, nx), x(nd, nx), l(nd), y(nx))

l = 1d0

do kx = 1, nx
    call random_number(y(kx))
    do kd = 1, nd
        call random_number(x(kd, kx))
    end do
end do

!-------------------------------------------------------------------------------
! Row-wise kernel
K = 0d0
call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call build_K(nd, nx, nx, x, x, l, K, kern_sqexp)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time build_K_vec:', toc - tic, 'ms'
print *, K(5,5), K(nx,nx-5)
print *, ''

! Nugget regularization
do kx = 1, nx
    K(kx, kx) = K(kx, kx) + 1d-10
end do

call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

! This doesn't touch anything above diagonal
print *, K(1,1:3)
print *, K(2,1:3)
print *, K(3,1:3)
call dpotrf('L', nx, K, nx, info)
print *, '------------------'
print *, K(1,1:3)
print *, K(2,1:3)
print *, K(3,1:3)

call system_clock(count, count_rate, count_max)

toc = count*1d3/count_rate
print *, 'Result Cholesky:', info
print *, 'Time Cholesky:', toc - tic, 'ms'
print *, ''

call system_clock(count, count_rate, count_max)
tic = count*1d3/count_rate

call dtrmv('L', 'N', 'N', nx, K, nx, y, 1)

call system_clock(count, count_rate, count_max)
toc = count*1d3/count_rate
print *, 'Time matmul:', toc - tic, 'ms'

deallocate(K, x, y, l)


end program bench_inline

module gpfunc
implicit none

type, abstract :: GP
  contains
  procedure(kern_elem), deferred, nopass :: kern
  procedure :: build_K_poly
end type GP

type, extends(GP) :: SqExpGP
  contains
  procedure, nopass :: kern => kern_sqexp_elem
end type SqExpGP

type Kernel
    procedure(abstract_kern), pointer, nopass :: kern
end type Kernel

type Kernel1D
    procedure(kern_1d), pointer, nopass :: kern
end type Kernel1D

type CompositeKernel
    type(Kernel1D), allocatable :: kernels(:)
end type CompositeKernel

abstract interface
    pure function kern_elem(ndim, xa, xb)
      integer, intent(in) :: ndim
      real(8), intent(in) :: xa(ndim), xb(ndim)
      real(8) :: kern_elem
    end function kern_elem

    subroutine abstract_kern(np, ndim, xa, xb, out)
        integer, intent(in) :: np, ndim
        real(8), intent(in) :: xa(np,ndim), xb(ndim)
        real(8), intent(out) :: out(np)
    end subroutine abstract_kern

    subroutine kern_1d(np, xa, xb, out)
        integer, intent(in) :: np
        real(8), intent(in) :: xa(np), xb
        real(8), intent(out) :: out(np)
    end subroutine kern_1d

end interface

contains

! Build kernel matrix polymorphism
subroutine build_K_poly(this, np, ndim, xa, xb, K)
  class(GP) :: this
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(ndim, np), xb(ndim, np) ! Points and hyperparams
  real(8), intent(inout) :: K(np, np)  ! Result matrix

  integer :: ka, kb

  !$omp parallel do
  do kb = 1, size(xb, 2)
    do ka = 1, size(xa, 2)
      K(ka, kb) = this%kern(ndim, xa(:, ka), xb(:, kb))
    end do
  end do

end subroutine build_K_poly

! Build kernel matrix
subroutine build_K(np, ndim, xa, xb, K, kern)
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(ndim, np), xb(ndim, np) ! Points and hyperparams
  real(8), intent(inout) :: K(np, np)  ! Result matrix
  external :: kern  ! Kernel function
  real(8) :: kern   ! Have to split these in two lines for f2py

  integer :: ka, kb

  !$omp parallel do
  do kb = 1, size(xb, 2)
    do ka = 1, size(xa, 2)
      K(ka, kb) = kern(ndim, xa(:, ka), xb(:, kb))
    end do
  end do

end subroutine build_K


subroutine build_K_sqexp(np, ndim, xa, xb, K)
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(np, ndim)
  real(8), intent(in)    :: xb(np, ndim)
  real(8), intent(inout) :: K(np, np)     ! Result matrix

  integer :: ka, kb

  !$omp parallel do
  do kb = 1, np
    !$omd simd
    do ka = 1, np
      K(ka, kb) = exp(-0.5d0*sum((xa(ka, :) - xb(kb, :))**2))
    end do
  end do
  !$omp end parallel do
end subroutine build_K_sqexp


subroutine build_K_sqexp_T(np, ndim, xa, xb, K)
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(ndim, np)
  real(8), intent(in)    :: xb(ndim, np)
  real(8), intent(inout) :: K(np, np)     ! Result matrix

  integer :: ka, kb

  !$omp parallel do
  do kb = 1, np
    !$omd simd
    do ka = 1, np
      K(ka, kb) = exp(-sum((xa(:, ka) - xb(:, kb))**2/2d0))
    end do
  end do
  !$omp end parallel do
end subroutine build_K_sqexp_T


subroutine build_ldKdl_sqexp(np, ndim, xa, xb, dim, dKdl)
  ! Returns matrix of l_d*dk/dl_d for dimension d
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(np, ndim)
  real(8), intent(in)    :: xb(np, ndim)
  integer, intent(in)    :: dim            ! Dimension towards to differentiate
  real(8), intent(inout) :: dKdl(np, np)   ! Derivative matrix

  real(8) :: xdiff(np, ndim)
  integer :: ka, kb

  do kb = 1, np
    do ka = 1, np
      dKdl(ka, kb) = -xdiff(ka, dim)*exp(-sum((xa(ka, :) - xb(kb, :))**2/2d0))
    end do
  end do
end subroutine build_ldKdl_sqexp


pure function kern_sqexp_elem(ndim, xa, xb)
    integer, intent(in) :: ndim
    real(8), intent(in) :: xa(ndim), xb(ndim)
    real(8) :: kern_sqexp_elem

    kern_sqexp_elem = exp(-0.5d0*sum((xa - xb)**2))

end function kern_sqexp_elem


subroutine kern_sqexp_vec(np, ndim, xa, xb, out)
    integer, intent(in) :: np, ndim
    real(8), intent(in) :: xa(np,ndim), xb(ndim)
    real(8), intent(out) :: out(np)

    integer :: ka

    !$omp simd
    do ka = 1, np
        out(ka) = exp(-sum((xa(ka, :) - xb)**2/2d0))
    end do

end subroutine kern_sqexp_vec


subroutine kern_sqexp_vec_T(np, ndim, xa, xb, out)
  integer, intent(in) :: np, ndim
  real(8), intent(in) :: xa(ndim, np), xb(ndim)
  real(8), intent(out) :: out(np)

  integer :: ka

  !$omp simd
  do ka = 1, np
      out(ka) = exp(-sum((xa(:, ka) - xb)**2/2d0))
  end do

end subroutine kern_sqexp_vec_T


! Build kernel matrix
subroutine build_K_vec(np, ndim, xa, xb, K, kern)
    integer, intent(in)    :: np, ndim
    real(8), intent(in)    :: xa(np, ndim), xb(np, ndim) ! Points and hyperparams
    real(8), intent(inout) :: K(np, np)  ! Result matrix
    external :: kern  ! Kernel function

    integer :: kb

    !$omp parallel do
    do kb = 1, np
        call kern(np, ndim, xa, xb(kb, :), K(:, kb))
    end do
    !$omp end parallel do

  end subroutine build_K_vec


! Build kernel matrix
subroutine build_K_vec_T(np, ndim, xa, xb, K, kern)
    integer, intent(in)    :: np, ndim
    real(8), intent(in)    :: xa(ndim, np), xb(ndim, np) ! Points and hyperparams
    real(8), intent(inout) :: K(np, np)  ! Result matrix
    external :: kern  ! Kernel function

    integer :: kb

    !$omp parallel do
    do kb = 1, np
        call kern(np, ndim, xa, xb(:, kb), K(:, kb))
    end do
    !$omp end parallel do

end subroutine build_K_vec_T


!-------------------------------------------------------------------------------
! Row-wise kernel with derived type and function pointer
subroutine build_K_der(np, ndim, xa, xb, K, kern)
    integer, intent(in)    :: np, ndim
    real(8), intent(in)    :: xa(np, ndim), xb(np, ndim) ! Points and hyperparams
    real(8), intent(inout) :: K(np, np)  ! Result matrix
    type(Kernel) :: kern  ! Kernel function container

    integer :: kb

    !$omp parallel do
    do kb = 1, np
        call kern%kern(np, ndim, xa, xb(kb, :), K(:, kb))
    end do
    !$omp end parallel do

end subroutine build_K_der



subroutine kern_sqexp_1D(np, xa, xb, out)
    integer, intent(in) :: np
    real(8), intent(in) :: xa(np), xb
    real(8), intent(out) :: out(np)

    out = exp(-(xa - xb)**2/2d0)

end subroutine kern_sqexp_1D


subroutine kern_one_1D(np, xa, xb, out)
  integer, intent(in) :: np
  real(8), intent(in) :: xa(np), xb
  real(8), intent(out) :: out(np)

  out = 1d0

end subroutine kern_one_1D


!-------------------------------------------------------------------------------
! Column-wise kernel with derived type and function pointer
subroutine build_K_prod(np, ndim, xa, xb, K, kerns)
    integer, intent(in)    :: np, ndim
    real(8), intent(in)    :: xa(np, ndim), xb(np, ndim) ! Points and hyperparams
    real(8), intent(inout) :: K(np, np)  ! Result matrix
    type(CompositeKernel) :: kerns  ! Kernel function container

    real(8) :: col(np)
    integer :: kb, kd

    K = 1d0

    !$omp parallel do private(col)
    do kd = 1, ndim
        do kb = 1, np
            call kerns%kernels(kd)%kern(np, xa(:, kd), xb(kb, kd), col)
            K(:, kb) = K(:, kb)*col
        end do
    end do
    !$omp end parallel do

end subroutine build_K_prod


subroutine kern_sqexp_vec2(nd, nx, x0, x1, out)
implicit none
INTEGER*4, intent(in) :: nd
INTEGER*4, intent(in) :: nx
REAL*8, intent(in), dimension(1:nd, 1:nx) :: x0
REAL*8, intent(in), dimension(1:nd, 1:nx) :: x1
REAL*8, intent(out), dimension(1:nd, 1:nx) :: out
INTEGER*4 :: kd
INTEGER*4 :: kx
do kx = 1, nx
   do kd = 1, nd
      out(kd, kx) = exp(-0.5d0*(-x0(kd, kx) + x1(kd, kx))**2)
   end do
end do
end subroutine


! Build kernel matrix
subroutine build_K_interface(np, ndim, xa, xb, K, kern)
  integer, intent(in)    :: np, ndim
  real(8), intent(in)    :: xa(ndim, np), xb(ndim, np) ! Points and hyperparams
  real(8), intent(inout) :: K(np, np)  ! Result matrix

  interface
    pure function kern(ndim, xa, xb)
      integer, intent(in) :: ndim
      real(8), intent(in) :: xa(ndim), xb(ndim)
      real(8) :: kern
    end function kern
  end interface

  integer :: ka, kb

  !$omp parallel do
  do kb = 1, size(xb, 2)
    do ka = 1, size(xa, 2)
      K(ka, kb) = kern(ndim, xa(:, ka), xb(:, kb))
    end do
  end do

end subroutine build_K_interface

end module gpfunc

##
using QuasiMonteCarlo: LowDiscrepancySample, sample
using Plots

lb = [0.0, -0.5]  # Lower bounds
ub = [4.0, 3.5]   # Upper bounds
n = 100           # Number of samples

halton = LowDiscrepancySample([3, 5])  # Halton with prime number sequence
xtrain = sample(n, lb, ub, halton)

scatter(xtrain[1,:], xtrain[2,:])
##

# f(x) = cos.(x[1,:]).*sin.(x[2,:])
# ytrain = f(xtrain)

# #scatter3d(xtrain[1,:], xtrain[2,:], ytrain, marker_z=ytrain)
# #savefig("test.png")

REAL*8 function kern_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
kern_num = sin(x_a - x_b)
end function
REAL*8 function dkdx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx_num = cos(x_a - x_b)
end function
INTEGER*4 function dkdy_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy_num = 0
end function
REAL*8 function dkdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdx0_num = -cos(x_a - x_b)
end function
INTEGER*4 function dkdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdy0_num = 0
end function
REAL*8 function d2kdxdx0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdx0_num = sin(x_a - x_b)
end function
INTEGER*4 function d2kdydy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdydy0_num = 0
end function
INTEGER*4 function d2kdxdy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d2kdxdy0_num = 0
end function
INTEGER*4 function d3kdxdx0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dy0_num = 0
end function
INTEGER*4 function d3kdydy0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dy0_num = 0
end function
INTEGER*4 function d3kdxdy0dy0_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dy0_num = 0
end function
INTEGER*4 function dkdlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdlx_num = 0
end function
INTEGER*4 function dkdly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
dkdly_num = 0
end function
INTEGER*4 function d3kdxdx0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dlx_num = 0
end function
INTEGER*4 function d3kdydy0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dlx_num = 0
end function
INTEGER*4 function d3kdxdy0dlx_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dlx_num = 0
end function
INTEGER*4 function d3kdxdx0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdx0dly_num = 0
end function
INTEGER*4 function d3kdydy0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdydy0dly_num = 0
end function
INTEGER*4 function d3kdxdy0dly_num(x_a, y_a, x_b, y_b, lx, ly)
implicit none
REAL*8, intent(in) :: x_a
REAL*8, intent(in) :: y_a
REAL*8, intent(in) :: x_b
REAL*8, intent(in) :: y_b
REAL*8, intent(in) :: lx
REAL*8, intent(in) :: ly
d3kdxdy0dly_num = 0
end function

module gpfunc
implicit none

contains

subroutine xdiff2_L2(nd, nb, xa, xb, l, xdiff2)
  integer, intent(in)    :: nd, nb             ! Dimension and number of points
  real(8), intent(in)    :: xa(nd), xb(nd, nb) ! Points
  real(8), intent(in)    :: l(nd)              ! Length scales
  real(8), intent(out)   :: xdiff2(nb)         ! Output: squared distance

  integer :: kb

  !$omp simd
  do kb = 1, nb
    xdiff2(kb) = sum(((xa - xb(:, kb))/l)**2)
  end do
end subroutine xdiff2_L2


subroutine build_K(nd, nxa, nxb, xa, xb, K, kern, l, sig2f, sig2n, periodic)
  ! Build a kernel matrix using a function `kern` to construct columns/rows
  integer, intent(in)    :: nd, nxa, nxb  ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, nxa), xb(nd, nxb) ! Points
  real(8), intent(inout) :: K(nxa, nxb)   ! Output: kernel matrix
  real(8), intent(in)    :: l(nd)         ! Length scales
  real(8), intent(in)    :: sig2f         ! Output scale covariance
  real(8), intent(in)    :: sig2n         ! Noise covariance
  logical, optional      :: periodic(nd)  ! `True` for periodic directions
  external :: kern  ! Kernel function `kern(nd, nx, xa, xb, out)`

  integer :: ka !, kb, kd
  real(8) :: xdiff2(nxb) ! xanorm(nd, nxa), xbnorm(nd, nxb)

  ! if (present(periodic)) then
  !   xbnorm = 0d0
  !   !$omp simd
  !   do kd = 1, nd
  !     if (periodic(kd)) then
  !       xanorm(kd, :) = sin(xa(kd, :) - xb(kd, :))/l(kd)
  !     else
  !       xanorm(kd, :) = (xa(kd, :) - xb(kd, :))/l(kd)
  !     endif
  !   end do
  ! else
  !   !$omp simd
  !   do kd = 1, nd
  !     xanorm(kd, :) = xa(kd, :)/l(kd)
  !     xbnorm(kd, :) = xb(kd, :)/l(kd)
  !   end do
  ! endif

  !$omp parallel do private(xdiff2)
  do ka = 1, nxa
    call xdiff2_L2(nd, nxb, xa(:, ka), xb, l, xdiff2)
    call kern(nxb, xdiff2, K(:, ka))
    K(:, ka) = sig2f*K(:, ka)
    K(ka, ka) = K(ka, ka) + sig2n
  end do
  !$omp end parallel do

end subroutine build_K


! TODO: Build dK/dl(kd)
! use dkern/kern as below
!
! TODO: Build K derivative observarion
! for sqexp Kxx = (1 - x)*K or something like this
! could give instead of dkern(x) better f=dkern(x)/kern(x)
! f : dkern = f*kern  (auto-differentiation and pullback similar)
! very cheap for sqexp (and periodic)
!
! build_L
!   loop over dimension and evaluate dkern d2kern
!
! build dL/dl(kd)


subroutine kern_sqexp(nx, xdiff2, out)
  integer, intent(in) :: nx
  real(8), intent(in) :: xdiff2(nx)
  real(8), intent(out) :: out(nx)

  out = exp(-0.5d0*xdiff2)
end subroutine kern_sqexp

end module gpfunc

module gpfunc
implicit none

contains

pure subroutine nu_L2(nd, na, xa, xb, th, nu)
  integer, intent(in)    :: nd, na             ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, na), xb(nd) ! Points
  real(8), intent(in)    :: th(nd)             ! Inverse length scales squared
  real(8), intent(out)   :: nu(na)             ! Output: 1/2*|x|^2

  integer :: ka

  !$omp simd
  do ka = 1, na
    nu(ka) = sum(th*(xa(:, ka) - xb)**2)
  end do
end subroutine nu_L2


subroutine d_nu_L2_dx(nd, na, xa, xb, l2inv, out)
  ! Gradient w.r.t. x of nu_L2
  integer, intent(in)    :: nd, na             ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, na), xb(nd) ! Points
  real(8), intent(in)    :: l2inv(nd)          ! Inverse length scales squared
  real(8), intent(out)   :: out(nd, na)        ! Output

  integer :: ka

  !$omp simd
  do ka = 1, na
    out(:, ka) = (xa(:, ka) - xb)*l2inv
  end do
end subroutine d_nu_L2_dx


subroutine d2_nu_L2_dx2(nd, na, xa, xb, l2inv, out)
  ! Gradient w.r.t. l of nu_L2
  integer, intent(in)    :: nd, na             ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, na), xb(nd) ! Points
  real(8), intent(in)    :: l2inv(nd)          ! Inverse length scales squared
  real(8), intent(out)   :: out(nd, na)        ! Output

  integer :: ka

  !$omp simd
  do ka = 1, na
    out(:, ka) = l2inv
  end do
end subroutine d2_nu_L2_dx2


pure subroutine kern_sqexp(nx, nu, out)
  integer, intent(in) :: nx
  real(8), intent(in) :: nu(nx)
  real(8), intent(out) :: out(nx)

  out = exp(-0.5d0*nu)
end subroutine kern_sqexp


subroutine build_K(nd, nxa, nxb, xa, xb, l2inv, K, kern)
  ! Build a kernel matrix using a function `kern` to construct columns/rows
  integer, intent(in)    :: nd, nxa, nxb  ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, nxa), xb(nd, nxb) ! Points
  real(8), intent(in)    :: l2inv(nd)     ! Inverse length scales squared
  real(8), intent(inout) :: K(nxa, nxb)   ! Output: kernel matrix
  external :: kern  ! Kernel function `kern(nx, nu, out)`

  integer :: kb
  real(8) :: nu(nxa)

  !$omp parallel do private(nu)
  do kb = 1, nxb
    ! Variant which constructs only lower diagonal
    !call nu_L2(nd, nxa-kb+1, xa(:, kb:), xb(:, kb), l2inv, nu)
    !call kern(nxa-kb+1, nu(:kb), K(kb:, kb))
     call nu_L2(nd, nxa, xa, xb(:, kb), l2inv, nu)
     call kern(nxa, nu, K(:, kb))
  end do
  !$omp end parallel do

end subroutine build_K


subroutine build_K_sqexp(nd, nxa, nxb, xa, xb, l2inv, K)
  ! Build a kernel matrix for square exp. kernel
  integer, intent(in)    :: nd, nxa, nxb  ! Dimension and number of points
  real(8), intent(in)    :: xa(nd, nxa), xb(nd, nxb) ! Points
  real(8), intent(in)    :: l2inv(nd)     ! Inverse length scales squared
  real(8), intent(inout) :: K(nxa, nxb)   ! Output: kernel matrix
  external :: kern  ! Kernel function `kern(nx, nu, out)`

  integer :: kb
  real(8) :: nu(nxa)

  !$omp parallel do private(nu)
  do kb = 1, nxb
    call nu_L2(nd, nxa, xa, xb(:, kb), l2inv, nu)
    call kern_sqexp(nxa, nu, K(:, kb))
  end do
  !$omp end parallel do

end subroutine build_K_sqexp


subroutine build_dKdth_sqexp(nd, nxa, nxb, kd, xa, xb, K, dK)
  ! Build a kernel matrix for square exp. kernel
  integer, intent(in)    :: nd, nxa, nxb  ! Dimension and number of points
  integer, intent(in)    :: kd  ! Dimension towards to differentiate
  real(8), intent(in)    :: xa(nd, nxa), xb(nd, nxb) ! Points
  real(8), intent(inout) :: K(nxa, nxb)   ! Input/Output: kernel matrix
  real(8), intent(inout) :: dK(nxa, nxb)  ! Output: derivative of kernel matrix
  external :: kern  ! Kernel function `kern(nx, nu, out)`

  integer :: kb

  !$omp parallel do
  do kb = 1, nxb
    dK(:, kb) = -0.5d0*(xb(kd, kb) - xa(kd, :))**2*K(:, kb)
  end do
  !$omp end parallel do

end subroutine build_dKdth_sqexp

end module gpfunc

module gpfast
  implicit none
contains

  function kern(x0, x1, a)
    real(8) :: x0(:), x1(:), a, kern
    kern = exp(-sqrt(sum((x1-x0)**2))/(2*a**2))
  end function kern

  subroutine gp_matrix(x0, x1, a, K)
    real(8) :: x0(:,:), x1(:,:), a, K(:,:)
    integer :: k0, k1, n0, n1
    n0 = size(x0)
    n1 = size(x1)
    do k1 = 1, n1
      do k0 = 1, n0
        K(k0, k1) = kern(x0(:,k0), x1(:,k1), a)
      end do
    end do
  end subroutine gp_matrix

end module gpfast

REAL*8 function kern_sqexp(r)
implicit none
REAL*8, intent(in) :: r
kern_sqexp = exp(-0.5d0*r**2)
end function
REAL*8 function dkern_sqexp(r)
implicit none
REAL*8, intent(in) :: r
dkern_sqexp = -r*exp(-0.5d0*r**2)
end function
REAL*8 function d2kern_sqexp(r)
implicit none
REAL*8, intent(in) :: r
d2kern_sqexp = (r**2 - 1)*exp(-0.5d0*r**2)
end function
REAL*8 function kern_matern32(r)
implicit none
REAL*8, intent(in) :: r
kern_matern32 = (sqrt(3.0d0)*r + 1)*exp(-1.7320508075688773d0*r)
end function
REAL*8 function dkern_matern32(r)
implicit none
REAL*8, intent(in) :: r
dkern_matern32 = -3*r*exp(-1.7320508075688773d0*r)
end function
REAL*8 function d2kern_matern32(r)
implicit none
REAL*8, intent(in) :: r
d2kern_matern32 = 3*(sqrt(3.0d0)*r - 1)*exp(-1.7320508075688773d0*r)
end function
REAL*8 function kern_matern52(r)
implicit none
REAL*8, intent(in) :: r
kern_matern52 = ((5.0d0/3.0d0)*r + sqrt(5.0d0)*r + 1)*exp( &
      -2.2360679774997897d0*r)
end function
REAL*8 function dkern_matern52(r)
implicit none
REAL*8, intent(in) :: r
dkern_matern52 = -1.0d0/3.0d0*(5*sqrt(5.0d0)*r + 15*r - 5)*exp( &
      -2.2360679774997897d0*r)
end function
REAL*8 function d2kern_matern52(r)
implicit none
REAL*8, intent(in) :: r
d2kern_matern52 = (5.0d0/3.0d0)*(5*r + 3*sqrt(5.0d0)*r - 2*sqrt(5.0d0) - &
      3)*exp(-2.2360679774997897d0*r)
end function
REAL*8 function kern_wend4(r)
implicit none
REAL*8, intent(in) :: r
kern_wend4 = (1 - r)**4*(4*r + 1)
end function
REAL*8 function dkern_wend4(r)
implicit none
REAL*8, intent(in) :: r
dkern_wend4 = 20*r*(r - 1)**3
end function
REAL*8 function d2kern_wend4(r)
implicit none
REAL*8, intent(in) :: r
d2kern_wend4 = (r - 1)**2*(80*r - 20)
end function

using BenchmarkTools
using Distances

##
function nu_L2!(nu, xa, xb, l)
  nu .= 0.0
  for ka = axes(xa, 2)
    @simd for kd = axes(xa, 1)
      @inbounds nu[ka] = nu[ka] + 0.5*(((xa[kd, ka] - xb[kd])/l[kd])^2)
    end
  end
end

function kern_sqexp!(out, nu)
  out[:] = exp.(-nu)
end

function build_K!(K, xa, xb, l, kern!, nufunc!)
  # Build a kernel matrix using a function `kern` to construct columns/rows
  nu = Array{Float64}(undef, size(xa, 2))
  for kb = axes(xb, 2)
    @views nufunc!(nu, xa, xb[:, kb], l)
    @views kern!(K[:, kb], nu)
  end
end

function kern_sqexp_elem(nu)
  exp(-nu)
end

@inline function nu_L2_elem(xa, xb, l)
  # mapreduce(k -> ((xa[k] - xb[k])/l[k])^2, +, axes(xa, 1)) / 2
  out = 0.0
  @inbounds @simd for k in axes(xa, 1)
    out += ((xa[k] - xb[k])/l[k])^2
  end
  out = 0.5*out
end


@inline function nu_L2_index(xa, xb, ka, kb, l)
  out = 0.0
  @inbounds @simd for k in axes(xa, 1)
    out += ((xa[k, ka] - xb[k, kb])/l[k])^2
  end
  out = 0.5*out
end

function build_K_elem!(K, xa, xb, l, kern::Function, nufunc::Function)
  # Build a kernel matrix using a function `kern` to construct elements
  @inbounds for kb = axes(xb, 2)
    for ka = axes(xa, 2)
      #@views nu = sqeuclidean(xa[:, ka], xb[:, kb])
      #@views nu = nu_L2_index(xa, xb, ka, kb, l)
      @views nu = nufunc(xa[:, ka], xb[:, kb], l)
      K[ka, kb] = kern(nu)
      #@views nu = nu_L2_elem(xa[:, ka], xb[:, kb], l)
      #K[ka, kb] = kern_sqexp_elem(nu)
    end
  end
end

nd = 4
na = 4096
nb = na

l = ones(nd)
xa = rand(nd, na)
xb = xa
K = zeros((na, nb))
##
@time build_K_elem!(K, xa, xb, l, kern_sqexp_elem, nu_L2_elem)
#@code_native build_K_elem!(K, xa, xb, l, kern_sqexp_elem, nu_L2_elem)
##
@time build_K!(K, xa, xb, l, kern_sqexp!, nu_L2!)
##
# @btime @views K = [kern_sqexp_elem(nu_L2_index(xa, xb, ka, kb, l)) for ka in axes(xa, 2), kb in axes(xb, 2)]
# print()
##
# using KernelFunctions

# k₁ = SqExponentialKernel()
# ##
# @time kernelmatrix!(K₁,k₁,xa,obsdim=2)
# print()

Run modes:

* UQ generator: fill folder with run folders based on template
* UQ runner: schedule runs for all run folders based on template
* UQ postprocessor: postprocesses results

* SM generator: compute next position for surrogate model
  * should be scheduled once last run is finished. 
    * how to recognize this? Simplest: "finished" file
  * based on some rule better than space filling grid
* SM runner: schedule next run for surrogate model

TODO:
* way how to read and store results from UQ
* how to treat symlinks?
  * should resolve symlinks for all template files, but not necessarily for others
* data file that links run dirs to parameter values
* extensibility: should be able to add runs afterwards
* cluster: should interact with qsub and qstat
* must be able to restart and continue runs!
* user should specify number and type of output quantities
* custom hooks while processing to be able to plot

* Backends config
  * redmod_conf.py
  * params.txt

* Backends UQ
  * uq.ChaosPy: chaospy PCE
  * uq.Dakota: Sandia's Dakota code
  * uq.VVUQ: Roland's PCE

* Backends SM
  * sm.GPFlow: GP
  * sm.VVGP: Roland's GP

* Backends RUN
  * run.PythonFunction: direct call via Python function
  * run.Subprocess: Parallel call with subprocesses
  * run.MPI: Distribute via MPI
  * run.Slurm: Use slurm qsub/qstat

# Contributing to proFit
Contributions to proFit are always welcome.

## Resources
* official repository on [github](https://github.com/redmod-team/profit)
  * [issue tracker](https://github.com/redmod-team/profit/issues)
  * pull requests
  * feature planning via *Projects*
  * automatic testing
  * managing releases
* official documentation on [readthedocs.io](https://profit.readthedocs.io/en/latest)
* meeting log on [HedgeDoc](https://pad.gwdg.de/lOiz56TIS4e5E9-92q-2MQ?view)
* internal documentation and ideas at the github wiki (for now. should be moved to readthedocs in the future)

to gain access to internal documentation and regular meetings please get in touch with Christopher Albert 
(albert@alumni.tugraz.at)

## Issues
If you encounter any bugs, problems or specific missing features, please open an issue on 
[github](https://github.com/redmod-team/profit/issues). Please state the bug / problem / enhancement clearly and provide
context information. 

## Organization and planning
Three types of [project boards](https://github.com/redmod-team/profit/projects) are used with the main repository.

**Vision** for strategy, use cases and user stories.

**Tasks** for prioritization and tracking issues and pull requests. Each version has it's own board.

**Testing** for gathering observations in preparation of a new release. 

## git
proFit uses *git* as VCS. The upstream repository is located at https://github.com/redmod-team/profit. Currently the
upstream repository contains only one branch.

Contributors should fork this repository, push changes to their fork and make *pull requests* to merge them back into 
upstream. Before merging, the pull request should be reviewed by a maintainer and any changes can be discussed. For
larger projects use *draft pull requests* to show others your current progress. They can also be tracked in the relevant
*Projects*, added to release schedules and features can be discussed easily.

To try out new features which have not been merged yet, you can just add any fork to your repository with 
`git remote add <name> <url>` and merge it locally. Do not push this merge to your fork.

The default method to resolve conflicts is to rebase the personal fork onto `upstream` before merging.

Please also use *interactive rebase* to squash intermediate commits if you use many small commits.

### Jupyter Notebooks
Make sure to clear output of Jupyter notebooks before committing them to the git repository.

## Documentation
The project documentation is maintained in the `doc` directory of the repository. proFit uses *Sphinx* and *rst* markup.
The documentation is automatically built from the repository and hosted on 
[readthedocs.io](https://profit.readthedocs.io/en/latest).

Code documentation is generated automatically using [Sphinx AutoAPI](https://github.com/readthedocs/sphinx-autoapi). 
Please describe your code using docstrings, preferably following the *Google Docstring Format*. For typing please use
the built in type annotations (PEP 484 / PEP 526).

### creating documentation
Creating the documentation requires additional packages (specify `docs` during `pip install`)

Running `make html` inside the `doc` folder creates output HTML file in `_build`.

## Packaging
proFit is still in development. There is currently no stable release. It is planned to manage releases on *github* and 
publish them on *PyPi*.

proFit uses the new build system, as specified by PEP 517. The build system is defined in `pyproject.toml` and uses the 
default `setuptools` and `wheels`.
Package metadata and requirements are specified in `setup.cfg`. Building the *fortran* backend requires a 
`setup.py` file and `numpy` installed during the build process.

Upon publishing a new release in *GitHub*, a workflow should automatically upload the package to *PyPI*.
To create a release manually follow this [guide](https://packaging.python.org/tutorials/packaging-projects/)

## Testing
proFit uses `pytest` for automatic testing. A pull request on *GitHub* triggers automatic testing with the supported
python versions. 

## Coding
### Dependencies
Some calls to proFit should be completed very fast, but our many dependencies can slow down the startup time 
significantly. Therefore be careful where you import big packages like `GPy` or `sklearn`. Consider using import 
statements at the start of the function.

Investigating the tree of imported packages can be done graphically with `tuna`:
```
python -X importtime -c "import profit" 2> profit_import.log
tuna profit_import.log
```

# Contributing to proFit
Contributions to proFit are always welcome.

## Resources
* repository on [github](https://github.com/redmod-team/profit)
  * [issue tracker](https://github.com/redmod-team/profit/issues)
  * pull requests
  * feature planning via *Projects*
  * automation via *Actions*
  * managing releases
* documentation on [readthedocs.io](https://profit.readthedocs.io/en/latest)
* meeting log on [HedgeDoc](https://pad.gwdg.de/lOiz56TIS4e5E9-92q-2MQ?view)
* archived on [zenodo.org](https://zenodo.org/record/6563463#.Yo9PjiNBxQo) with DOI `10.5281/zenodo.3580488`
* python package published on [PyPI](https://pypi.org/project/profit/)
* test coverage on [coveralls.io](https://coveralls.io/github/redmod-team/profit)

to gain access to internal documentation and regular meetings please get in touch with Christopher Albert
(albert@tugraz.at)

## Issues
If you encounter any bugs, problems or specific missing features, please open an issue on
[github](https://github.com/redmod-team/profit/issues). Please state the bug / problem / enhancement clearly and provide
context information.

## Organization and planning
Three types of [project boards](https://github.com/redmod-team/profit/projects) are used with the main repository.

**Vision** for strategy, use cases and user stories.

**Tasks** for prioritization and tracking issues and pull requests. Each version has it's own board.

**Testing** for gathering observations in preparation of a new release.

## git
proFit uses *git* as VCS. The upstream repository is located at https://github.com/redmod-team/profit. Currently the
upstream repository contains only one branch.

Contributors should fork this repository, push changes to their fork and make *pull requests* to merge them back into
upstream. Before merging, the pull request should be reviewed by a maintainer and any changes can be discussed. For
larger projects use *draft pull requests* to show others your current progress. They can also be tracked in the relevant
*Projects*, added to release schedules and features can be discussed easily.

To try out new features which have not been merged yet, you can just add any fork to your repository with
`git remote add <name> <url>` and merge it locally. Do not push this merge to your fork.

The default method to resolve conflicts is to rebase the personal fork onto `upstream` before merging.

Please also use *interactive rebase* to squash intermediate commits if you use many small commits.

### Pre-Commit Hooks
Starting with the development for `v0.6`, proFit uses *pre-commit* to ensure consistent formatting with
[black](https://github.com/psf/black) and clean jupyter notebooks.
Pre-commit is configured with `.pre-commit-config.yaml` and needs to be activated with `pre-commit install`.
To run the hooks on all files (e.g. after adding new hooks), use `pre-commit run --all-files`.

## Installing
Install proFit from your git repository using the editable install: `pip install -e .[docs,dev]`.

## Documentation
The project documentation is maintained in the `doc` directory of the repository. proFit uses *Sphinx* and *rst* markup.
The documentation is automatically built from the repository on every commit and hosted on
[readthedocs.io](https://profit.readthedocs.io/en/latest).

Code documentation is generated automatically using [Sphinx AutoAPI](https://github.com/readthedocs/sphinx-autoapi).
Please describe your code using docstrings, preferably following the *Google Docstring Format*. For typing please use
the built in type annotations (PEP 484 / PEP 526).

To build the documentation locally, run `make html` inside the `doc` folder to create the output HTML in `_build`.
This requires the additonal dependencies `docs`

## Versioning
proFit follows semantic versioning (`MAJOR.MINOR.PATCH`).
Each version comes with a *git tag* and a *Release* on GitHub.
proFit is still in development, comes with no gurantees of backwards compatability and is therefore using versions `v0.x`.
The minor version is incremented when significant features have been implemented or projects completed.
Each minor version is tracked with a *Project* in GitHub and receives release notes when published.
It is good practice to create a release candidate `v0.xrc` before a release.
The release candidate should be tagged as *pre-release* in GitHub. It will not be shown per default on *PyPI* and *readthedocs*.

Releases are created with the GitHub interface and trigger workflows to automate the publishing and packaging. In particular:
* A python package is created an uploaded to [PyPI](https://pypi.org/project/profit/)
* The repository is archived and a new version added to [zenodo](https://zenodo.org/record/6563463#.Yo9PjiNBxQo)
* A new version of the documentation is created on [readthedocs](https://profit.readthedocs.io)

Before creating a version, check the metadata in `setup.cfg` (for the python package) and `.zenodo.json` (for zenodo).

proFit infers it's version from the installed metadata or the local git repository and displays it when called.

## Packaging
proFit uses the new python build system, as specified by PEP 517.
The build system is defined in `pyproject.toml` and uses the default `setuptools` and `wheels`.
Package metadata and requirements are specified in `setup.cfg`.
Building the *fortran* backend requires a `setup.py` file and `numpy` installed during the build process.

Upon publishing a new release in *GitHub*, a workflow automatically builds and uploads the package to *PyPI*.
To create a release manually follow this [guide](https://packaging.python.org/tutorials/packaging-projects/).

## Testing
proFit uses `pytest` for automatic testing. A pull request on *GitHub* triggers automatic testing with the supported python versions.
The *GitHub* action also determines the test coverage and uploads it to [coveralls](https://coveralls.io/github/redmod-team/profit).

## Coding
### Dependencies
Some calls to proFit should be completed very fast, but our many dependencies can slow down the startup time
significantly. Therefore be careful where you import big packages like `GPy` or `sklearn`. Consider using import
statements at the start of the function.

Investigating the tree of imported packages can be done graphically with `tuna`:
```
python -X importtime -c "import profit" 2> profit_import.log
tuna profit_import.log
```
